'$stop_scan
#include once "fbgfx.bi"

#include once "font.bas"

randomize timer

' General Constants
CONST PI         AS DOUBLE = 3.1415926535897932384626433832795
CONST Radians    AS DOUBLE = PI / 180
CONST DEG_TO_RAD AS DOUBLE = PI / 180
CONST RAD_TO_DEG AS DOUBLE = 180 / PI

enum weapon_type
   W_CIRCLE = 0
   W_LINE
   W_WOBBLE
   W_SONAR
   W_TOTAL
end enum
   

Type point2d
   As Double x, y
End Type

Type stats
   As Integer health, max_health
   As Integer armour, max_armour
   As Integer power, max_power
   As Double  speed, max_speed
End Type

Type weapon
   As Integer  damage
   As Integer  power_req
   As Integer  size
   As Integer  spread
   As Double   speed
   As Double   freq
   as integer  range
   as integer  arc
   As integer  Type
End Type

Type player
   As point2d  Pos, vel, acc
   As stats    stats
   As Double   rot
   As weapon   gun
   As Short    active
   As integer  Reload
End Type

Type powerup
   As point2d  Pos, vel
   As weapon   bonus
   As Short    active
End Type

Type bullet
   As weapon   stats
   As point2d  Pos, vel, acc
   as uinteger color
   As Short    active
End Type

Type asteroid
   As point2d  Pos, vel
   As Integer  health
   As Integer  size
   As Integer  vert( 10 )
   As Short    active
End Type

Type message
   As String   value
   As point2d  Pos
   As Short    active
End Type

type particle
   as point2d     pos, vel
   as uinteger     color
   as short       active
end type

Type game
   as integer     countdown
   As player      player
   As player      enemy( 500 )
   As integer     i_enemy
   As bullet      bullet( 500 )
   as integer     i_bullet
   As powerup     powerup( 3 )
   as integer     i_powerup
   As Integer     wave
   As Integer     Enemy_Quota
   As Integer     score
   As Integer     shots
   As Integer     hits
   As message     msg( 20 )
   As integer     i_msg
   As Particle    Particle( 500 )
   As integer     i_particle
End Type

Sub DrawShip ( x As Double, y As Double, r As Double, c As Integer )
   
   dim as double r1, r2, ox, oy, cr1, cr2, sr1, sr2
   
   r1 = (r - 140) * Radians
   r2 = (r + 140) * Radians
   
   ox = (Cos(r*Radians)*7)
   oy = (Sin(r*Radians)*7)
   
   cr1 = Cos(r1) * 7
   cr2 = Cos(r2) * 7
   sr1 = Sin(r1) * 7
   sr2 = Sin(r2) * 7
   
   Line (x + (cr1), y+ (sr1))-(x + ox, y+oy),c
   Line (x + (cr2), y+ (sr2))-(x + ox, y+oy),c
   Line (x + (cr2), y+ (sr2))-(x, y),c
   Line (x + (cr1), y+ (sr1))-(x, y), c
   
End Sub

' Angle calcuation from normalized vector
FUNCTION CalcAngle (x AS DOUBLE, y AS DOUBLE) AS DOUBLE
	
	DIM AS DOUBLE Angle
	Angle = ATN(y / x) * RAD_TO_DEG
	
	' NorthEast Quad
	IF (x <= 0) AND (y >= 0) THEN
		Angle = 360 + Angle
	ELSEIF (x >= 0) AND (y >= 0) THEN ' NorthWest Quad
		Angle = 180 + Angle
	ELSEIF (x >= 0) AND (y <= 0) THEN ' SouthWest Quad
		Angle = 180 + Angle
	END IF
	
	RETURN Angle MOD 360

END FUNCTION

' Shortest turn path
FUNCTION SmartTurn (Angle AS DOUBLE, DesAngle AS DOUBLE) AS INTEGER
	IF DesAngle > Angle THEN
		IF (DesAngle - Angle) <= ((Angle + 360) - DesAngle) THEN
			RETURN 1
		ELSE
			RETURN -1
		END IF
	END IF
 	IF DesAngle < Angle THEN
		IF (Angle - DesAngle) < ((DesAngle + 360) - Angle) THEN
			RETURN -1
		ELSE
			RETURN 1
		END IF
	END IF
	RETURN 0
END FUNCTION

FUNCTION CalcDist ( x1 AS DOUBLE, y1 AS DOUBLE, x2 AS DOUBLE, y2 AS DOUBLE ) AS DOUBLE
	RETURN (((x1 - x2) * (x1 - x2)) + ((y1 - y2) * (y1 - y2)))
END FUNCTION

Function Play () As Integer
   
   ' Set defaults
   
   Dim As game    game
   
   With game.player
      .pos.x = 400
      .pos.y = 300
      .rot = -90
      .stats.max_health = 25
      .stats.health = .stats.max_health
      .stats.max_armour = 25
      .stats.armour = .stats.max_armour
      .stats.max_power = 25
      .stats.power = .stats.max_power
      .stats.max_speed = 0.01
      .stats.speed = .stats.max_speed
      
      .gun.damage = 1
      .gun.power_req = 2
      .gun.size = 1
      .gun.spread = 0
      .gun.speed = 2
      .gun.range = 75
      .gun.freq = 50
      .gun.type = 0

   End With
   
   game.hits = 1
   game.shots = 1
   game.wave = 0
   game.Enemy_Quota = 0
   game.countdown = 5
   
   dim as string t
   t = time
   
   Do
      with game
      ' Create enemies
      ' position enemies at screen edge
      if ( .i_enemy < 500 ) and ( .enemy_quota > 0 ) and ( .countdown = 0 ) then
         for i as uinteger = 0 to 500
            if .enemy( i ).active = 0 then
               .enemy( i ).stats.health = .wave
               .enemy_quota -= 1
               .enemy( i ).vel.x = 0
               .enemy( i ).vel.y = 0
               .i_enemy += 1
               if rnd < 0.5 then
                  .enemy( i ).pos.x = int( rnd * 2 ) * 800
                  .enemy( i ).pos.y = int( rnd * 600 )
               else
                  .enemy( i ).pos.x = int( rnd * 800 )
                  .enemy( i ).pos.y = int( rnd * 2 ) * 600 
               end if
               .enemy( i ).active = 1
               exit for
            end if
         next i
      end if
      
      if ( .i_enemy = 0 ) and ( .enemy_quota = 0 ) and ( .countdown = 0 ) then
         .countdown = 5
      end if
      
      if .countdown > 0 then
         if t <> time then
            t = time
            .countdown -= 1
            if .countdown = 0 then
               game.wave += 1
               game.Enemy_Quota = game.wave * 5
               game.i_enemy = 0
               
               ' Upgrade!
               line ( 350, 250 )-STEP( 100, 100 ), RGBA( 0, 255, 0, 32 ),BF
               line ( 350, 250 )-STEP( 100, 100 ), RGBA( 0, 255, 0, 128 ),B
               
               Text , 354, 254, "WEAPON UPGRADE", RGB( 255, 255, 0 )
               
               dim as integer i
               i = 20
               Text , 354, 254 + i, "(1) DAMAGE", RGB( 255, 255, 255 )
               i += 6
               Text , 354, 254 + i, "(2) MULTI SHOT", RGB( 255, 255, 255 )
               i += 6
               Text , 354, 254 + i, "(3) SPREAD", RGB( 255, 255, 255 )
               i += 6
               Text , 354, 254 + i, "(4) RATE", RGB( 255, 255, 255 )
               i += 6
               Text , 354, 254 + i, "(5) SIZE", RGB( 255, 255, 255 )
               i += 6
               Text , 354, 254 + i, "(6) TTL", RGB( 255, 255, 255 )
               i += 6
               Text , 354, 254 + i, "(7) VELOCITY", RGB( 255, 255, 255 )
               i += 6

               Text , 354, 254 + i, "(8) REPAIR SHIP", RGB( 255, 255, 255 )
               i += 6


               dim as string k
               
               while inkey$ <> "": wend
               
               do
                  k = inkey$
                  
                  select case k
                  case "1"
                     game.player.gun.damage += 2
                     exit do
                  case "2"
                     game.player.gun.spread += 1
                     if game.player.gun.arc = 0 then game.player.gun.arc = 3
                     exit do
                  case "3"
                     game.player.gun.arc += 3
                     if game.player.gun.arc > 180 then game.player.gun.arc = 180
                     exit do                     
                  case "4"
                     game.player.gun.freq *= 0.75
                     if game.player.gun.freq < 1 then game.player.gun.freq = 1
                     exit do
                  case "5"
                     game.player.gun.size += 1
                     exit do                       
                  case "6"
                     game.player.gun.range += 3
                     exit do
                  case "7"
                     game.player.gun.speed += 0.3
                     exit do                       
                  case "8"
                     game.player.stats.health = game.player.stats.max_health
                     exit do 
                     
                  end select
                  
                  sleep 50
               loop         
               
               
            end if
            

            
         end if
      end if
      end with
      
      ' Calc player position
      with game.player
      
'      if multikey( FB.SC_G ) then
'         .gun.damage = 1
'         .gun.power_req = rnd * 25 + 1
'         .gun.size = rnd * 5 + 1
'         .gun.spread = rnd * 5
'         .gun.speed = rnd * 5 + 1
'         .gun.range = rnd * 100 + 10
'         .gun.freq = rnd * 100 + 1
'         .gun.arc = rnd * 180
'      end if
      
      
      .Reload -= 1
      
      if multikey( FB.SC_RIGHT ) then .rot += 1.5
      if multikey( FB.SC_LEFT ) then .rot -= 1.5
      
      if multikey( FB.SC_Z ) then .gun.type = W_CIRCLE
      if multikey( FB.SC_X ) then .gun.type = W_WOBBLE
      if multikey( FB.SC_C ) then .gun.type = W_SONAR
      
      .rot = (.rot + 360 ) mod 360
      
      'if multikey( FB.SC_SPACE ) then
         if .Reload <= 0 then
            .Reload = .gun.freq
            if ( .gun.spread > 0 ) and ( .gun.arc > 0 ) then
            
               for i as double = -.gun.arc to .gun.arc step .gun.arc / .gun.spread
                  game.shots += 1
                  game.bullet( game.i_bullet ).active = 1
                  game.bullet( game.i_bullet ).color = RGB( 255, 255, 255 )
                  game.bullet( game.i_bullet ).pos = .pos
                  game.bullet( game.i_bullet ).vel.x = cos( (.rot + ( i ) ) * Radians ) * .gun.speed
                  game.bullet( game.i_bullet ).vel.y = sin( (.rot + ( i ) ) * Radians ) * .gun.speed
                  game.bullet( game.i_bullet ).stats = .gun
                  game.i_bullet = ( game.i_bullet + 1 ) mod 500
               
               next i
               
            else
               game.shots += 1
               game.bullet( game.i_bullet ).active = 1
               game.bullet( game.i_bullet ).color = RGB( 255, 255, 255 )
               game.bullet( game.i_bullet ).pos = .pos
               game.bullet( game.i_bullet ).vel.x = cos( (.rot ) * Radians ) * .gun.speed
               game.bullet( game.i_bullet ).vel.y = sin( (.rot ) * Radians ) * .gun.speed
               game.bullet( game.i_bullet ).stats = .gun
               game.i_bullet = ( game.i_bullet + 1 ) mod 500
               
            end if
            
         end if
      'end if
      
      if multikey( FB.SC_UP ) then
         .acc.x = cos( .rot * Radians ) * .stats.speed
         .acc.y = sin( .rot * Radians ) * .stats.speed
         if rnd < 0.2 then
         game.particle( game.i_particle ).active = 1
         game.particle( game.i_particle ).color = RGB( 255, 255 - ( rnd * 255 ), 0 )
         game.particle( game.i_particle ).pos = .pos
         game.particle( game.i_particle ).vel.x = ( -cos( .rot * Radians ) ) + ( ( rnd - 0.5 ) * 0.2 )
         game.particle( game.i_particle ).vel.y = ( -sin( .rot * Radians ) ) + ( ( rnd - 0.5 ) * 0.2 )
         game.i_particle = int( rnd * 501 )
         end if
      end if

      if multikey( FB.SC_DOWN ) then
         .acc.x = -cos( .rot * Radians ) * .stats.speed
         .acc.y = -sin( .rot * Radians ) * .stats.speed
         if rnd < 0.2 then
         game.particle( game.i_particle ).active = 1
         game.particle( game.i_particle ).color = RGB( 255, 255 - ( rnd * 255 ), 0 )
         game.particle( game.i_particle ).pos = .pos
         game.particle( game.i_particle ).vel.x = ( cos( .rot * Radians ) ) + ( ( rnd - 0.5 ) * 0.2 )
         game.particle( game.i_particle ).vel.y = ( sin( .rot * Radians ) ) + ( ( rnd - 0.5 ) * 0.2 )
         game.i_particle = int( rnd * 501 )
         end if
      end if


      .vel.x += .acc.x
      .vel.y += .acc.y

      .pos.x += .vel.x
      .pos.y += .vel.y
      
      if .pos.x < 0 then .pos.x += 800
      if .pos.y < 0 then .pos.y += 600
      if .pos.x > 800 then .pos.x -= 800
      if .pos.y > 600 then .pos.y -= 600

      .acc.x = 0
      .acc.y = 0
      
      end with
      
      screenlock
      
      ' Fade screen
      line ( 0, 0 )-( 800, 600 ), RGBA( 0, 0, 0, 32 ), BF

      ' Draw Particles
      for i as uinteger = 0 to 500
         with game.particle( i )
         
         .vel.x *= 0.99
         .vel.y *= 0.99
         
         .pos.x += .vel.x
         .pos.y += .vel.y
         
         if .active then
            
            pset ( .pos.x, .pos.y ), .color
            
         end if
         
         if ( abs(.vel.x) < 0.1 ) And ( abs(.vel.y) < 0.1 ) then .active = 0
         
         end with
         
         ' BULLETS
         with game.bullet( i )
         
         if .stats.type <> W_SONAR then
            .pos.x += .vel.x
            .pos.y += .vel.y
            if ( .pos.x < 0 ) then .pos.x = 800
            if ( .pos.x > 800 ) then .pos.x = 0
            if ( .pos.y < 0 ) then .pos.y = 600
            if ( .pos.y > 600 ) then .pos.y = 0            
         else
            .stats.size += 1
         end if
         
         
         
         if .active then
            
            if .stats.type = W_CIRCLE then
               circle( .pos.x, .pos.y ), .stats.size, RGB( 255, 255, 0 ),,,,F
            elseif .stats.type = W_WOBBLE then
               .vel.x += (( rnd - 0.5 ) )
               .vel.y += (( rnd - 0.5 ) )
               line ( .pos.x, .pos.y )-STEP( .vel.x * .stats.size, .vel.y * .stats.size ),RGB( 0, 0, 255 )
            elseif .stats.type = W_SONAR then
               circle( .pos.x, .pos.y ), .stats.size, RGB( 0, 128, 0 )
            end if
            
         end if
         
         .stats.range -= 1
         
         if .stats.range < 0 then .active = 0
         
         end with      
      
      next i

      ' Draw Bullets
      for i as uinteger = 0 to 500

         ' ENEMIES
         with game.enemy( i )
            
            if .active = 1 then
               
               ' collide with player?
               if calcdist( game.player.pos.x, game.player.pos.y, .pos.x, .pos.y ) < 49 then
                  game.player.stats.health -= 1
                  game.player.vel.x = .vel.x * 0.5
                  game.player.vel.y = .vel.y * 0.5
                  .vel.x = -.vel.x * 0.5
                  .vel.y = -.vel.y * 0.5
                  
                  .active = 0
                  game.i_enemy -= 1
                  for p as integer = 0 to 25
                  
                     game.particle( game.i_particle ).active = 1
                     game.particle( game.i_particle ).color = RGB( 255, 255 - ( rnd * 255 ), 0 )
                     game.particle( game.i_particle ).pos = .pos
                     game.particle( game.i_particle ).vel.x = ( ( rnd - 0.5 ) * 3 )
                     game.particle( game.i_particle ).vel.y = ( ( rnd - 0.5 ) * 3 )
                     game.i_particle = int( rnd * 501 )                     
                  
                  next p                  
                  
'                  with game.player
'                  dim as integer  r = int(rnd * 8 )
'                  select case r
'                  case 0
'                  .gun.damage -= 1
'                  if .gun.damage < 1 then .gun.damage = 1
'                  case 1
'                  .gun.size -= 1
'                  if .gun.size < 1 then .gun.size = 1
'                  case 2
'                  .gun.spread -= 1
'                  if .gun.spread < 0 then .gun.spread = 0
'                  case 3
'                  .gun.speed -= 1
'                  if .gun.speed < 2 then .gun.speed = 2
'                  case 4
'                  .gun.range -= 1
'                  if .gun.range < 75 then .gun.range = 75
'                  case 5
'                  .gun.freq *= 1.25
'                  case 6
'                  .gun.arc -= 3
'                  if .gun.arc < 0 then .gun.arc = 0
'                  end select
'                  end with
                  
               end if
               
               ' collided with bullet?
               for b as integer = 0 to 500
                  if game.bullet( b ).active = 1 then
                     if calcdist( game.bullet( b ).pos.x, game.bullet( b ).pos.y, .pos.x, .pos.y ) < ( ( 7 + game.bullet(b).stats.size ) * ( 7 + game.bullet(b).stats.size ) ) then
                        
                        if game.bullet( b ).stats.type <> W_SONAR then
                           
                           game.bullet( b ).active = 0
                           
                           game.hits += 1
                           .stats.health -= game.bullet( b ).stats.damage
                           
                           if .stats.health <= 0 then
                              
                              game.score += game.wave * 10 + ( 10 * int( game.hits / game.shots * 100 ) )
                              .active = 0
                              game.i_enemy -= 1
                              for p as integer = 0 to 25
                              
                                 game.particle( game.i_particle ).active = 1
                                 game.particle( game.i_particle ).color = RGB( 255, 255 - ( rnd * 255 ), 0 )
                                 game.particle( game.i_particle ).pos = .pos
                                 game.particle( game.i_particle ).vel.x = ( ( rnd - 0.5 ) * 3 )
                                 game.particle( game.i_particle ).vel.y = ( ( rnd - 0.5 ) * 3 )
                                 game.i_particle = int( rnd * 501 )                     
                              
                              next p
                           else
                              .vel.x += game.bullet( b ).vel.x * 0.5
                              .vel.y += game.bullet( b ).vel.y * 0.5

                              for p as integer = 0 to 5
                              
                                 game.particle( game.i_particle ).active = 1
                                 game.particle( game.i_particle ).color = RGB( 255, 255 - ( rnd * 255 ), 0 )
                                 game.particle( game.i_particle ).pos = .pos
                                 game.particle( game.i_particle ).vel.x = ( ( rnd - 0.5 ) * 2 )
                                 game.particle( game.i_particle ).vel.y = ( ( rnd - 0.5 ) * 2 )
                                 game.i_particle = int( rnd * 501 )                     
                              
                              next p
                              
                           end if
                        else
                           .vel.x = 0
                           .vel.y = 0
                        end if
                        
                        
                        exit for
                     end if
                  end if
               next b

               ' always face the player
               dim as integer nrot = CalcAngle( .pos.x - game.player.pos.x, .pos.y - game.player.pos.y )
               
               if abs( nrot - .rot ) > 5 then
                  .rot += SmartTurn( .rot, nrot )
                  .rot = ( .rot + 360 ) mod 360
               end if

               if rnd > 0.49 then
                  .acc.x = cos( .rot * DEG_TO_RAD ) * 0.05
                  .acc.y = sin( .rot * DEG_TO_RAD ) * 0.05
               else
                  .acc.x = -cos( .rot * DEG_TO_RAD ) * 0.05
                  .acc.y = -sin( .rot * DEG_TO_RAD ) * 0.05
               end if


               .vel.x += .acc.x
               .vel.y += .acc.y
               
'               if .vel.x > 0.5 then .vel.x = 0.5
'               if .vel.x < -0.5 then .vel.x = -0.5
'               if .vel.y > 0.5 then .vel.y = 0.5
'               if .vel.y < -0.5 then .vel.y = -0.5
               
               if ( .pos.x < 0 ) then .pos.x = 800
               if ( .pos.x > 800 ) then .pos.x = 0
               if ( .pos.y < 0 ) then .pos.y = 600
               if ( .pos.y > 600 ) then .pos.y = 0
               
               .pos.x += .vel.x
               .pos.y += .vel.y
               
               DrawShip .pos.x, .pos.y, .rot, RGB( 255, 0, 0 )
               
               .vel.x *= 0.999
               .vel.y *= 0.999
               
            end if
            
         end with

      next i
      
      
      
      ' Draw Player
      
      With game.player
         
         dim as double  health_colour = (.stats.health / .stats.max_health ) * 255
         
         DrawShip .pos.x, .pos.y, .rot, Rgb( 255 - health_colour, health_colour, 0 )
         
      End With
      
      line ( -1, -1 )-( 100, 30 ), RGBA( 0, 0, 255, 32 ), BF
      line ( -1, -1 )-( 100, 30 ), RGBA( 0, 0, 255, 128 ), B
      Text , 6, 4,  "WAVE   " & game.wave, RGB( 255, 255, 255 )
      Text , 6, 12, "SCORE  " & game.score, RGB( 255, 255, 255 )
      Text , 6, 20, "HEALTH " & game.player.stats.health, RGB( 255, 255, 255 )
      
      screenunlock
      
      sleep 5

      if game.player.stats.health <= 0 then
         
         Text ,250,250,"GAME OVER!", RGB( 255, 255, 0 )
         
         while inkey$ <> "": wend
         
         sleep
         
         return 0
      end if

   Loop Until Multikey( FB.SC_ESCAPE )
   
   Return 0
   
End Function

Screenres 800,600,32,, FB.GFX_ALPHA_PRIMITIVES
LoadFont( "5x5.fnt" )
Play()


